<template>
  <v-app>
    <v-app-bar
      app
      color="primary"
      dark
    >
      <div class="d-flex align-center">
        <h3> GAO</h3>
      </div>

      <v-spacer></v-spacer>

      <v-btn
        v-if="isLogedIn" 
        @click.prevent="logOut"
        text
      >
        <v-icon>mdi-logout</v-icon>
      </v-btn>
    </v-app-bar>

    <v-main>
      <router-view/>
    </v-main>
    <v-snackbar
      :timeout="timeout"
      :value="show"
      absolute
      centered
      :color="color"
      elevation="5"
    >
      {{message}}
    </v-snackbar>
  </v-app>
</template>

<script>
import AuthenticationService from './services/AuthenticationService'
import EventBusEnum from './enum/EventBusEnum'
import Utils from './helpers/Utils'
export default {
  name: 'App',
  data: () => ({
    timeout: -1,
    show: false,
    color: 'green',
    message:'Info message',
    isLogedIn: AuthenticationService.isLogedIn()
  }),

  watch: {
      $route (to, from) {
        this.isLogedIn = AuthenticationService.isLogedIn()
      }
  },
  created () {
    let self = this
    Utils.eBusOnMethod(EventBusEnum.EVENT_SNACKBAR, function (payLoad) {
        self.timeout = payLoad.timeout
        self.message = payLoad.message
        self.color = payLoad.color
        self.show = payLoad.show
        setTimeout(()=> {
          self.show = false
        },3000)

      // console.log("playload ", self.timeout, self.message, self.color, self.show)
    });
  },
  methods: {
    logOut (){
     AuthenticationService.logout()
    }
  }
}
</script>
